/*
***********************************************************************
*
* Copyright (C) 1999 Ericsson Radio Systems AB
* 
* The Association of Radio Industries and Businesses (ARIB) has the
* licence to reproduce, distribute and publish the Bit Exact C Code
* programs in this CD-ROM together with the other parts of the RCR
* STD-27 (Personal Digital Cellular Telecommunication System)
* specification.
* 
* Ericsson has declared Option 1 (royalty-free licence) to ARIB for
* its Essential Industrial Property Rights related to the ACELP
* specification and the Bit Exact C Code programs. The royalty-free
* licence is limited to the development and manufacturing of
* products complying with the RCR STD-27H specification (or
* subsequent versions) for sale and use in Japan. Copying of the
* program(s) for any other purpose requires the prior written
* permission from Ericsson.
* 
* The user of the Bit Exact C Code hereby acknowledges the
* following:
* 
* 1.  Ericsson does not provide the user with any warranties,
*     whether express or implied, including but not limited to
*     warranties of merchantability and fitness for a particular
*     purpose relating to the Bit Exact C Code.
* 
* 2.  Ericsson shall have no responsibility whatsoever to indemnify
*     the user against actions or claims for infringement of any
*     intellectual property rights, e.g. patents, copyrights,
*     registered designs or any other rights, by reason of the
*     user's use of the Bit Exact C Code.
* 
***********************************************************************
*/

#include "typedef.h"
#include "basic_op.h"
#include "cnst.h"
#include "reord_ch.tab"

/*************************************************************************
 *
 *  FUNCTION: reorderEFRtoFRchannelFormat
 *
 *  PURPOSE:  Reordering of the serial stream from PDC-EFR to PDC-FR
 *            format. The same chc scheme as for FR may then be used
 *            for EFR.
 *
 *************************************************************************/
void reorderEFRtoFRchannelFormat(
    Word16 serial[]  /* (i/o) : serial bits (134 (+ bfi))     */
)
{
    Word16 i;
    Word16 serialCopy[SERIAL_SIZE];

    for (i = 0; i < SERIAL_SIZE; i++) {
       serialCopy[i] = serial[i];
    }

    for (i = 3; i < SERIAL_SIZE; i++) {
       serial[ REORD_efr2fr[i-3] + 3 ] = serialCopy[i];
    }

    return;
}

/*************************************************************************
 *
 *  FUNCTION: reorderFRtoEFRchannelFormat
 *
 *  PURPOSE:  Reordering of the serial stream from PDC-FR to PDC-EFR
 *            format. The same chc scheme as for FR may then be used
 *            for EFR.
 *
 *************************************************************************/
void reorderFRtoEFRchannelFormat(
    Word16 serial[]  /* (i/o) : serial bits (134 (+ bfi))     */
)
{
    Word16 i;
    Word16 serialCopy[SERIAL_SIZE];

    for (i = 0; i < SERIAL_SIZE; i++) {
       serialCopy[i] = serial[i];
    }

    for (i = 3; i < SERIAL_SIZE; i++) {
       serial[i] = serialCopy[ REORD_efr2fr[i-3] + 3 ];
    }

    return;
}

